/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.benutzerverwaltung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.benutzerverwaltung.boundary.AbstractRolleSearchParameters;
import de.ivu.elect.business.benutzerverwaltung.boundary.RolleChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.boundary.RolleConversationStore;
import de.ivu.elect.business.benutzerverwaltung.boundary.RolleExtendedDAO;
import de.ivu.elect.business.benutzerverwaltung.boundary.RolleSearch;
import de.ivu.elect.business.benutzerverwaltung.boundary.RolleSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.entity.Rolle;
import de.ivu.elect.business.benutzerverwaltung.entity.RolleMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractRolleSearchView.COMPONENT_NAME)
@View(viewId = AbstractRolleSearchView.VIEW_ID, useCase = UseCasePermission.ROLLE_SEARCH)
public abstract class AbstractRolleSearchView extends AbstractElectSearchView<Rolle> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "rolleSearchView";
  
  public static final String VIEW_ID = "/benutzerverwaltung/rolle-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractRolleSearchView requestHandler;

  @Inject
  private transient RolleExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(RolleConversationStore.class)
  protected transient RolleConversationStore conversationStore;

  @Inject
  protected transient RolleSearch search;

  @Inject
  @ConversationGroup(AbstractRolleSearchParameters.class)
  protected transient RolleSearchParameters searchParameters;

  @Inject
  protected transient RolleMeta entityMeta;

  public AbstractRolleSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Rolle getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Rolle entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public RolleSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Rolle> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Rolle> create();
  }

  @Override
  public List<Rolle> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Rolle> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onRolleChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) RolleChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractRolleSearchView {

    @View
    @Inject
    private transient Instance<AbstractRolleSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractRolleSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
